package gg.malloc.defense.commands;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import gg.malloc.defense.engine.GameRunner;

import gg.malloc.defense.Plugin;

public class LeaveGameCommand implements CommandExecutor {
  Plugin m_plugin;

  public LeaveGameCommand(Plugin plugin) {
    m_plugin = plugin;
  }

  @Override
  public boolean onCommand(CommandSender sender, Command command, String s, String[] args) {
    if (sender instanceof Player) {
      Player player = (Player)sender;
      GameRunner runner = m_plugin.getRunnerForPlayer(player);
      if (runner == null) {
        sender.sendMessage("You are not currently in a game.");
        return true;
      }
      runner.removePlayer(player);
      m_plugin.removePlayerFromGames(player);
      m_plugin.returnPlayerToLobby(player);
    } else {
      sender.sendMessage("Only players may use this command.");
    }
    return true;
  }
}

